import type { GomokuDirectionType } from './constant';
import type { IGomokuBoard } from './types';
export declare class GomokuContext {
    readonly MAX_ROW: number;
    readonly MAX_COL: number;
    readonly MAX_INLINE: number;
    readonly TOTAL_POS: number;
    readonly TOTAL_PLAYERS: number;
    readonly board: Readonly<IGomokuBoard>;
    constructor(MAX_ROW: number, MAX_COL: number, MAX_INLINE: number);
    idx(r: number, c: number): number;
    idxIfValid(r: number, c: number): number;
    reIdx(id: number): [r: number, c: number];
    isValidPos(r: number, c: number): boolean;
    isInvalidPos(r: number, c: number): boolean;
    move(r: number, c: number, dirType: GomokuDirectionType, step?: number): [r2: number, c2: number];
    visitValidNeighbors(r: number, c: number, touch: (r2: number, c2: number, dirType: GomokuDirectionType) => void): void;
    hasPlacedNeighbors(r: number, c: number): boolean;
    /**
     * Traverse in the recursive order.
     * @param handle
     */
    traverseAllDirections(handle: (r: number, c: number, dirType: GomokuDirectionType) => void): void;
    traverseLeftDirections(handle: (r: number, c: number, dirType: GomokuDirectionType) => void): void;
    traverseRightDirections(handle: (r: number, c: number, dirType: GomokuDirectionType) => void): void;
}
