import type { GomokuDirectionType } from './constant';
import type { GomokuContext } from './GomokuContext';
import type { IScoreMap, IShapeCount } from './types';
export declare class GomokuCountMap {
    protected readonly context: GomokuContext;
    protected readonly dirCountMap: Uint32Array[];
    protected readonly conShapeCountMap: IShapeCount[][];
    protected readonly gapShapeCountMap: IShapeCount[][];
    protected readonly scoreMap: IScoreMap;
    protected readonly NEXT_MOVER_FAC: number;
    constructor(context: GomokuContext, scoreMap: IScoreMap, NEXT_MOVER_FAC?: number);
    init(): void;
    beforeForward(r: number, c: number): void;
    afterForward(r: number, c: number): void;
    beforeRollback(r: number, c: number): void;
    afterRollback(r: number, c: number, player: number): void;
    score(currentPlayer: number, scoreForPlayer: number): number;
    hasReachedTheLimit(player: number): boolean;
    toJSON(): {
        dirCountMap: Uint32Array[];
        conShapeCountMap: IShapeCount[][];
        gapShapeCountMap: IShapeCount[][];
    };
    protected updateRelatedConShapeCountMap(centerR: number, centerC: number, startCnt: number, dirType: GomokuDirectionType, v: number): void;
    protected updateConShapeCountMap(player: number, startR: number, startC: number, cnt: number, dirType: GomokuDirectionType, v: number): void;
    protected updateGapShapeCountMap(player: number, lftCnt: number, rhtCnt: number, countOfFreeSide: number, v: number): void;
    protected detectGapContinuousLine(r: number, c: number, player: number, dirType: GomokuDirectionType): [lftCnt: number, rhtCnt: number, countOfFreeSide: number] | null;
    protected detectFreeSide(r: number, c: number, dirType: GomokuDirectionType): [cnt: number, countOfFreeSide: 0 | 1];
    protected detectExpandable(player: number, startR: number, startC: number, cnt: number, dirType: number): number;
    protected countDangerShapes(player: number): number;
}
